struct RemainingPlace {
    id: String,
    description: String,
    date: String,
    free: usize
}

fn main() -> Result<(), reqwest::Error> {
    // const URL: &str = "https://www.lfs.sachsen.de/restplatzboerse-5152.html";
    const URL: &str = "http://127.0.0.1:8080/tip.html";

    let body = reqwest::blocking::get(URL).unwrap().text().unwrap();

    let start = body.find("<tbody").unwrap();
    let end = body.find("</tbody>").unwrap();

    let table = &body[start..=(end + 7)];

    let mut places: Vec<RemainingPlace> = Vec::new();
    let mut iter = table.lines();

    while let Some(line) = iter.next() {
        if line.contains("<tr>") {
            let id = parse_node(iter.next().unwrap());
            let description = parse_node(iter.next().unwrap());
            let date = parse_node(iter.next().unwrap());
            let free = parse_node(iter.next().unwrap()).parse().unwrap();

            let place = RemainingPlace { id, description, date, free };
            places.push(place);
        }
    }

    for place in places {
        println!("{} - {} - {} - {}", place.id, place.description, place.date, place.free);
    }

    Ok(())
}

fn parse_node(input: &str) -> String {
    let start = input.find(">").unwrap();
    let end = input.find("</").unwrap();

    input[(start + 1)..end].to_string()
}
